Dim  g_SrcPath
If IsEmpty( g_SrcPath ) Then  MsgBox "This is vbslib object file." : WScript.Quit
Dim  g_ErrorInformationLib_vbs : get_DefineInfoObject  g_ErrorInformationLib_vbs, g_SrcPath


 
'********************************************************************************
'  <<< [ErrorInformationClass] >>> 
'********************************************************************************

Dim  g_ErrorInformationClass

Function    get_ErrorInformationClass()
  If IsEmpty( g_ErrorInformationClass ) Then _
    Set g_ErrorInformationClass = new ErrorInformationClass : ErrCheck
  Set get_ErrorInformationClass =   g_ErrorInformationClass
End Function


Class  ErrorInformationClass
	Public  InformationPath
	Public  RootPath

	'// Set by "Search" method
	Public  Matched   '// as Empty or ErrorLineInformationClass
	Public  Previous  '// as Empty or ErrorLineInformationClass
	Public  Next_     '// as Empty or ErrorLineInformationClass

	Private Sub  Class_Initialize()
		Me.RootPath = GetParentFullPath( g_ErrorInformationLib_vbs.FullPath )
		Me.InformationPath = Me.RootPath + "\ErrorInformation.Err.lines"
	End Sub


 
'********************************************************************************
'  <<< [ErrorInformationClass::Make] >>> 
'********************************************************************************
Sub  Make( RootPath )
	Set c = g_VBS_Lib

	ExpandWildcard  RootPath +"\*.Err.lines", c.File or c.SubFolder,_
		folder, input_paths

	echo  ">ErrorInformationClass::Make"
	Set ec = new EchoOff


	'// Make frame of "ErrorInformation.Err.lines" file
	Set cs = new_TextFileCharSetStack( "UTF-8" )
	CreateFile  Me.InformationPath, _
		"<?xml version=""1.0"" encoding=""UTF-8""?>"+vbCRLF+_
		"<Informations xml:space=""preserve"">"+vbCRLF+_
		"</Informations>"+vbCRLF
	cs = Empty


	'// Add "*.Err.lines" file to "ErrorInformation.Err.lines" file
	Set file = OpenForAppendXml( Me.InformationPath, Empty )
	For Each step_input_path  In input_paths
		input_path = GetFullPath( step_input_path, folder )

		ec = Empty
		echo  "Reading """+ step_input_path +""" ..."
		Set ec = new EchoOff

		UpdateLineInformationXML  input_path

		file.WriteXml  Replace(_
			ReadFile( input_path ),_
			"<Informations xml:space=""preserve"">", "<Informations>" )
	Next
	file = Empty


	'// Check not duplicate file name
	Const  NotCaseSensitive = 1
	Set file_names = CreateObject( "Scripting.Dictionary" )
	file_names.CompareMode = NotCaseSensitive

	Set xml_root = LoadXML( Me.InformationPath, Empty )
	For Each file_tag  In xml_root.selectNodes( "./File" )
		file_name = "result, "+ file_tag.getAttribute( "name" )
		If file_names.Exists( file_name ) Then _
			Raise 1, "<ERROR msg=""File name is duplicated."" name="""+ file_name +"""/>"
	Next

	ec = Empty
	echo  "Updated """+ Me.InformationPath +""""
End Sub


 
'********************************************************************************
'  <<< [ErrorInformationClass::Search] >>> 
'********************************************************************************
Sub  Search( Path, LineNum )

	Assert  LineNum >= 1

	Me.Matched  = Empty
	Me.Previous = Empty
	Me.Next_    = Empty


	echo  ">ErrorInformationClass::Search  "+ g_fs.GetFileName( Path ) +", "& LineNum
	Set ec = new EchoOff


	'// Set "file_tag" of Path by searching file name
	file_name_lower = LCase( g_fs.GetFileName( Path ) )
	Set xml_root = LoadXML( Me.InformationPath, Empty )
	xml_root.ownerDocument.setProperty "SelectionLanguage", "XPath"
	Set file_tag = xml_root.selectSingleNode( "./File[translate(@name,"+_
		"'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"+_
		" = '"+ file_name_lower +"']" )

	If file_tag is Nothing Then _
		Exit Sub


	'// Search line number in Info tags
	previous_line_num = 0
	previous_info_tag = Empty
	is_found = False
	For Each info_tag  In file_tag.selectNodes( "./Info" )

		info_line_num = CInt2( info_tag.selectSingleNode( "./Line" ).text )
		If info_line_num = LineNum Then
			Set Me.Matched = new ErrorLineInformationClass
			Me.Matched.SetFrom  info_tag
			is_found = True
			Exit For
		ElseIf info_line_num > LineNum Then
			If not IsEmpty( previous_info_tag ) Then
				Set Me.Previous = new ErrorLineInformationClass
				Me.Previous.SetFrom  previous_info_tag
			End If
			Set Me.Next_ = new ErrorLineInformationClass
			Me.Next_.SetFrom  info_tag
			is_found = True
			Exit For
		End If

		Set previous_info_tag = info_tag
	Next
	If ( not is_found ) and ( not IsEmpty( previous_info_tag ) ) Then
		Set Me.Previous = new ErrorLineInformationClass
		Me.Previous.SetFrom  previous_info_tag
	End If
End Sub


 
'********************************************************************************
'  <<< [ErrorInformationClass::SearchResultString] >>> 
'********************************************************************************
Property Get  SearchResultString()
	If not IsEmpty( Me.Matched ) Then
		SearchResultString = Me.Matched.EN +vbCRLF+ Me.Matched.JP
	ElseIf ( not IsEmpty( Me.Previous ) ) or ( not IsEmpty( Me.Next_ ) ) Then
		str = ""
		If not IsEmpty( Me.Previous ) Then _
			str = str + "(information)previous line("& Me.Previous.LineNum &") information :"+vbCRLF+_
				Me.Previous.EN +vbCRLF+ Me.Previous.JP + vbCRLF
		If not IsEmpty( Me.Next_ ) Then _
			str = str + "(information)next line("& Me.Next_.LineNum &") information :"+vbCRLF+_
				Me.Next_.EN +vbCRLF+ Me.Next_.JP + vbCRLF
		str = str + vbCRLF + "There is not error information at the line number."
		SearchResultString = str
	Else
		SearchResultString = "There is not error information at the file name."
	End If
End Property


 
End Class


 
'********************************************************************************
'  <<< [ErrorLineInformationClass] >>> 
'********************************************************************************
Class  ErrorLineInformationClass
	Public  LineNum
	Public  Text
	Public  JP
	Public  EN

	Sub SetFrom( InfoTag )
		Me.LineNum = CInt2( InfoTag.selectSingleNode( "./Line" ).text )
		Me.Text    = InfoTag.selectSingleNode( "./Text" ).text
		Me.JP      = InfoTag.selectSingleNode( "./JP" ).text
		Me.EN      = InfoTag.selectSingleNode( "./EN" ).text
	End Sub
End Class


 
