Dim g_g : Sub GetMainSetting( g ) : If not IsEmpty(g_g) Then Set g=g_g : Exit Sub
	Set g=CreateObject("Scripting.Dictionary") : Set g_g=g


	'[Setting]
	'==============================================================================
	g("CheckingTranslatedFolders") = "..\..\..\..\..\.."
	g("TranslateFolders") = Array(_
		"..\..\..",_
		"..\..\..\..\..\..\src" )
	'==============================================================================
End Sub

Sub  Main( Opt, AppKey )
	Set o = new InputCommandOpt
		Set o.CommandReplace = Dict(Array(_
			"1","TranslateTest",_
			"2","Translate",_
			"3","CheckEnglishOnly",_
			"4","RemoveNotEnglish",_
			"5","MakeAPartOfSettingForCheckEnglish",_
			_
			"TranslateTest","TranslateTest_sth",_
			"Translate","Translate_sth",_
			"CheckEnglishOnly","CheckEnglishOnly_sth",_
			"RemoveNotEnglish","RemoveNotEnglish_sth" ))
	InputCommand  o, Empty, Opt, AppKey
End Sub


 
'********************************************************************************
'  <<< [TranslateTest_sth] >>> 
'********************************************************************************
Sub  TranslateTest_sth( Opt, AppKey )
	GetMainSetting  g
	Set c = g_VBS_Lib

	echo  "Checking not remained Japanese after translating from English"

	For Each folder_path  In g("TranslateFolders")
		ExpandWildcard  folder_path +"\*.trans", c.File or c.SubFolder or c.AbsPath, dummy, paths
		For Each path  In paths
			TranslateTest  path, "JP", "EN", ""
		Next
	Next
	echo  "Checked."
End Sub


 
'********************************************************************************
'  <<< [Translate_sth] >>> 
'********************************************************************************
Sub  Translate_sth( Opt, AppKey )
	GetMainSetting  g
	Set w_= AppKey.NewWritable( g("CheckingTranslatedFolders") ).Enable()

	Set c = g_VBS_Lib
	setup_vbs      = "..\..\..\setup.vbs"
	setup_test_vbs = "..\..\..\setup_test.vbs"

	echo  "Make back up, if you want."
	If exist( setup_vbs ) Then _
		echo  "Make back up "+ setup_vbs +", too."
	If exist( setup_test_vbs ) Then _
		echo  "Make back up "+ setup_test_vbs +", too."
	key = input( "Translating to English, OK? [Y/N]" )
	If key<>"y" and key<>"Y" Then   Exit Sub  ' ... Cancel


	'// Back up japanese setup.vbs
	If exist( setup_vbs ) Then
		If InStr( ReadFile( setup_vbs ), "Calling ""Main"" function" ) = 0 Then
			copy_ren  setup_vbs, AddLastOfFileName( setup_vbs, ".jp.vbs" )
		End If
	else
		del  "setup.trans"
	End If


	'// Back up japanese setup_test.vbs
	If exist( setup_test_vbs ) Then
		If InStr( ReadFile( setup_test_vbs ), "Calling ""Main"" function" ) = 0 Then
			copy_ren  setup_test_vbs, AddLastOfFileName( setup_test_vbs, ".jp.vbs" )
		End If
	else
		del  "setup_test.trans"
	End If


	'// Translate
	For Each  folder_path  In g("TranslateFolders")
		ExpandWildcard  folder_path +"\*.trans", c.File or c.SubFolder, folder, step_paths
		For Each  step_path  In step_paths
			Translate  folder +"\"+ step_path, "JP", "EN"
		Next
	Next

	echo  "Translated."
End Sub


 
'********************************************************************************
'  <<< [CheckEnglishOnly_sth] >>> 
'********************************************************************************
Sub  CheckEnglishOnly_sth( Opt, AppKey )
	GetMainSetting  g

If False Then
	Set founds = CheckEnglishOnly( g("CheckingTranslatedFolders"), "SettingForCheckEnglish.ini" )

	For Each file  In founds.Items
		For Each found  In file.NotEnglishItems.Items
			echo  file.Path +"("& found.LineNum  &"): "+ found.NotEnglishText
		Next
	Next
End If

	out_path      = "CheckEnglishOnly_out.txt"
	ini_path      = "SettingForCheckEnglish.ini"
	part_ini_path = "_APartOfSettingForCheckEnglish.ini"

	Set w_= AppKey.NewWritable( Array( out_path, ini_path, part_ini_path ) ).Enable()
	del  out_path


	'// Update "SettingForCheckEnglish.ini
	MakeAPartOfSettingForCheckEnglish_Sub  part_ini_path

	Set file = OpenForReplace( ini_path, Empty )
	file.ReplaceRange _
		";<APartOfSettingForCheckEnglish>"+vbCRLF, _
		";</APartOfSettingForCheckEnglish>", _
		_
		";<APartOfSettingForCheckEnglish>"+vbCRLF+ _
		ReadFile( part_ini_path ) + _
		";</APartOfSettingForCheckEnglish>"
	file = Empty
	del  part_ini_path


	'// Run "CheckEnglishOnly.exe"
	CheckEnglishOnly_exe = g_vbslib_ver_folder +"CheckEnglishOnly\CheckEnglishOnly.exe"
	r = RunProg( """"+ CheckEnglishOnly_exe +""" /Folder:"+ g("CheckingTranslatedFolders") +_
		" /Setting:SettingForCheckEnglish.ini",_
		out_path )
	echo  "exit code = "& r

	If r = 0 Then
		del  out_path
	Else
		start  out_path
		Assert  false
	End If

End Sub


 
'********************************************************************************
'  <<< [RemoveNotEnglish_sth] >>> 
'********************************************************************************
Sub  RemoveNotEnglish_sth( Opt, AppKey )
	Raise  1, "Not supported."
End Sub


 
'********************************************************************************
'  <<< [MakeAPartOfSettingForCheckEnglish] >>> 
'********************************************************************************
Sub  MakeAPartOfSettingForCheckEnglish( Opt, AppKey )
	out_path = "_APartOfSettingForCheckEnglish.ini"
	Set w_= AppKey.NewWritable( out_path ).Enable()
	MakeAPartOfSettingForCheckEnglish_Sub  out_path
End Sub

Sub  MakeAPartOfSettingForCheckEnglish_Sub( OutPath )
	GetMainSetting  g
	Set c = g_VBS_Lib
	Set trans_files = new ArrayClass

	For Each folder_path  In g("TranslateFolders")
		ExpandWildcard  folder_path +"\*.trans", c.File or c.SubFolder or c.AbsPath, dummy, paths
		For Each path  In paths
			trans_files.Add  path
		Next
	Next

	MakeSettingForCheckEnglish  OutPath, trans_files.Items
	echo  "Created "+ OutPath
End Sub


 







'--- start of vbslib include ------------------------------------------------------ 

'// Calling "Main" function from inside of here.
'// And searching "scriptlib" folder and include vbslib.

'// vbslib is provided under 3-clause BSD license.
'// Copyright (C) 2007-2014 Sofrware Design Gallery "Sage Plaisir 21" All Rights Reserved.

Dim  g_Vers : If IsEmpty( g_Vers ) Then
Set  g_Vers = CreateObject("Scripting.Dictionary") : g_Vers("vbslib") = 99.99
Dim  g_debug, g_debug_params, g_admin, g_vbslib_path, g_CommandPrompt, g_fs, g_sh, g_AppKey
Dim  g_MainPath, g_SrcPath, g_f, g_include_path, g_i, g_debug_tree, g_debug_process, g_is_compile_debug
Dim  g_is64bitWSH
g_SrcPath = WScript.ScriptFullName : g_MainPath = g_SrcPath
SetupVbslibParameters
Set  g_fs = CreateObject( "Scripting.FileSystemObject" )
Set  g_sh = WScript.CreateObject("WScript.Shell") : g_f = g_sh.CurrentDirectory
g_sh.CurrentDirectory = g_fs.GetParentFolderName( WScript.ScriptFullName )
For g_i = 20 To 1 Step -1 : If g_fs.FileExists(g_vbslib_path) Then  Exit For
g_vbslib_path = "..\" + g_vbslib_path  : Next
If g_fs.FileExists(g_vbslib_path) Then  g_vbslib_path = g_fs.GetAbsolutePathName( g_vbslib_path )
g_sh.CurrentDirectory = g_f
If g_i=0 Then WScript.Echo "Not found " + g_fs.GetFileName( g_vbslib_path ) +vbCR+vbLF+_
	"Let's download vbslib and Copy scriptlib folder." : Stop : WScript.Quit 1
Set g_f = g_fs.OpenTextFile( g_vbslib_path,,,-2 ): Execute g_f.ReadAll() : g_f = Empty
If ResumePush Then  On Error Resume Next
	CallMainFromVbsLib
ResumePop : On Error GoTo 0
End If
'---------------------------------------------------------------------------------

Sub  SetupDebugTools()
	set_input  ""
	SetBreakByFName  Empty
	SetStartSectionTree  ""
End Sub

Sub  SetupVbslibParameters()
	'--- start of parameters for vbslib include -------------------------------
	'// g_Vers("OldMain") = 1
	g_vbslib_path = "scriptlib\vbs_inc.vbs"
	g_CommandPrompt = 1

	g_debug = 0   '// release:0, debug:99, -1:call SetupDebugTools
	              '// You can debug, if g_debug = 1 and installed MS Office or Visual Studio
	              '// Write "Stop" at start of step running or the place of watching the value of variable.

	'--- end of parameters for vbslib include ---------------------------------
End Sub
'--- end of vbslib include --------------------------------------------------------


 
