'*************************************************************************
'  <<< [HexToDec] >>> 
'*************************************************************************
Function  HexToDec( ByVal HexString )
	If StrComp( Left( HexString, 2 ), "0x", 1 ) = 0 Then
		HexString = Mid( HexString, 3 )
	End If
	HexToDec = CLng( "&h" + HexString )
End Function


 
'*************************************************************************
'  <<< [CalculateCheckSum] >>> 
'*************************************************************************
Function  CalculateCheckSum( ByVal HexString )
	CalculateCheckSum = 0

	If VarType( HexString ) <> vbString Then
		HexString = Hex( HexString )
	End If

	While  HexString <> ""
		byte_data = Left( HexString, 2 )
		HexString = Mid( HexString, 3 )
		CalculateCheckSum = CalculateCheckSum + CLng( "&h" + byte_data )
	WEnd
End Function


 
'*************************************************************************
'  <<< [WriteFillSRec] >>> 
'*************************************************************************
Sub  WriteFillSRec( Stream, StartAddress, OverAddress, FillData )
	Const num_16_line_byte = 16

	size = OverAddress - StartAddress
	If size mod num_16_line_byte <> 0 Then _
		Raise  1, "Data size must be multiple of "& num_16_line_byte


	Assert  Len( FillData ) = 2
	fill_data = UCase( FillData )
	For i = 1 To num_16_line_byte
		fill_data_16 = fill_data_16 + fill_data
	Next
	check_sum_16 = CalculateCheckSum( fill_data_16 )


	Stream.WriteLine  "S0070000737265634B"
	address = StartAddress
	While  size >= num_16_line_byte
		check_sum = 0
		line = "S3"

		'// Add record length
		record_length = 4 + num_16_line_byte + 1  '// address(4) + data(16) + checksum(1)
		line = line + Hex( record_length )
		check_sum = check_sum + CalculateCheckSum( record_length )

		'// Add address
		address_str = Right( "0000000"+ Hex( address ), 8 )
		line = line + address_str
		check_sum = check_sum + CalculateCheckSum( address_str )

		'// Add data
		line = line + fill_data_16
		check_sum = check_sum + check_sum_16

		'// Add check sum
		line = line + Right( "0"+ Hex( &hFFFFFFFF - check_sum ), 2 )

		'// Write
		Stream.WriteLine  line

		size = size - num_16_line_byte
		address = address + num_16_line_byte
	WEnd

	Stream.WriteLine  "S70500000000FA"
End Sub


 
'*************************************************************************
'  <<< [SRecToBin] >>> 
'*************************************************************************
Sub  SRecToBin( InputSRecPath, OutputPath, Opt )
	echo  ">SRecToBin """+ InputSRecPath +""" """+ OutputPath +""""
	Set ec = new EchoOff

	exe = g_vbslib_folder +"vbslib_n\vbslib_n_helper.exe"
	AssertExist  exe

	g_AppKey.CheckWritable  OutputPath, Empty

	command_line = """"+ exe +""" /silent SRecToBin """+ InputSRecPath +""" """&_
		OutputPath &""""

	r= RunProg( command_line, "" )
	Assert  r = 0
End Sub


 
'*************************************************************************
'  <<< [BinToSRec] >>> 
'*************************************************************************
Sub  BinToSRec( InputBinaryPath, OutputSRecPath, Comment, LoadAddress, ExecuteAddress, Opt )
	echo  ">BinToSRec """+ InputBinaryPath +""" """+ OutputSRecPath +""""
	Set ec = new EchoOff

	exe = g_vbslib_folder +"vbslib_n\vbslib_n_helper.exe"
	AssertExist  exe

	g_AppKey.CheckWritable  OutputSRecPath, Empty

	command_line = """"+ exe +""" /silent BinToSRec """+ InputBinaryPath +""" """&_
		OutputSRecPath &""" """& Comment &""" """&_
		LoadAddress &""" """& ExecuteAddress &""""

	r= RunProg( command_line, "" )
	Assert  r = 0
End Sub


 
'*************************************************************************
'  <<< [SetDefaultEnvironmentVariables] >>> 
'*************************************************************************
Sub  SetDefaultEnvironmentVariables()
	Dim  name,  value,  index,  overwrite,  ec
	Dim  defaults : defaults = GetDefaultEnvironmentVariables()
	If ArgumentExist( "silent" ) Then  Set ec = new EchoOff

	If g_fs.FileExists( "overwrite.vbs" ) Then
		include  "overwrite.vbs"
		Set overwrite = Dict( GetOverwriteEnvironmentVariables() )
	Else
		Set overwrite = CreateObject( "Scripting.Dictionary" )
	End If

	For index = 0  To UBound( defaults ) - 1  Step 2
		name  = defaults( index )
		value = defaults( index + 1 )

		If overwrite.Exists( name ) Then _
			value = overwrite.Item( name )

		SetVar  name, env( value )
	Next
End Sub


 
'********************************************************************************
'  <<< [GenerateCSourceFromBinaryFile] >>> 
'********************************************************************************
Sub  GenerateCSourceFromBinaryFile( Binary, VariableName, OutC_Source, OutH_Source )
	If VarType( Binary ) = vbString  and  VarType( OutC_Source ) = vbString  and _
			VarType( OutH_Source ) = vbString Then
		GenerateCSourceFromBinaryFile_C  Binary, VariableName, OutC_Source, OutH_Source
	Else
		GenerateCSourceFromBinaryFile_VBS  Binary, VariableName, OutC_Source, OutH_Source
	End If
End Sub


 
'********************************************************************************
'  <<< [GenerateCSourceFromBinaryFile_C] >>> 
'********************************************************************************
Sub  GenerateCSourceFromBinaryFile_C( BinaryPath, VariableName, OutC_SourcePath, OutH_SourcePath )
	echo  ">GenerateCSourceFromBinaryFile """+ BinaryPath +""" "+ VariableName +_
		" """+ OutC_SourcePath +""" """+ OutH_SourcePath +""""
	Set ec = new EchoOff

	exe = g_vbslib_folder +"vbslib_n\vbslib_n_helper.exe"
	AssertExist  exe

	If IsEmpty( VariableName ) Then
		var_name = "(NoVariable)"
	Else
		var_name = VariableName
	End If

	command_line = """"+ exe +""" /silent GenerateCSourceData """+ BinaryPath +""" """&_
		var_name &""" """+ OutC_SourcePath +""" """+ OutH_SourcePath +""""

	r= RunProg( command_line, "" )
	Assert  r = 0
End Sub


 
'********************************************************************************
'  <<< [GenerateCSourceFromBinaryFile_VBS] >>> 
'********************************************************************************
Sub  GenerateCSourceFromBinaryFile_VBS( BinaryPath, VariableName, OutC_SourceStream, OutH_SourceStream )

	If TypeName( BinaryPath ) = "BinaryArray" Then
		echo  ">GenerateCSourceFromBinaryFile "& VariableName
		Set ec = new EchoOff

		Set bin = BinaryPath
	Else
		echo  ">GenerateCSourceFromBinaryFile """+ BinaryPath +""" "& VariableName
		Set ec = new EchoOff

		AssertExist  BinaryPath
		Set bin = new BinaryArray : bin.Load  BinaryPath
	End If

	file_size = "0x"+ Hex( bin.Size )
	OutC_SourceStream.WriteLine  "typedef unsigned char  uint8_t;"
	If not IsEmpty( VariableName ) Then
		OutC_SourceStream.WriteLine  "const uint8_t  "+ VariableName +"["+ file_size +"] = {"
		OutH_SourceStream.WriteLine  "extern const uint8_t  "+ VariableName +"["+ file_size +"];"
	End If

	x_offset = 0
	line = ""
	For offset = 0  To bin.Size - 1
		line = line + " 0x"+ Right( "0"+ Hex( bin( offset ) ), 2 ) +","

		If x_offset = &h0F Then
			OutC_SourceStream.WriteLine  vbTab + Mid( line, 2 )
			line = ""
			x_offset = 0
		Else
			x_offset = x_offset + 1
		End If
	Next

	If line <> "" Then _
		OutC_SourceStream.WriteLine  vbTab + Mid( line, 2 )
	If not IsEmpty( VariableName ) Then
		OutC_SourceStream.WriteLine  "};"
	End If
End Sub


 
'********************************************************************************
'  <<< [UpdateLineInformationXML] >>> 
'********************************************************************************
Sub  UpdateLineInformationXML( LineInfoXML_Path )
	Dim  root,  file_element,  info_elements,  info_element,  info_num
	Dim  source_path,  source,  line,  line_text,  last_update_line_num
	Dim  temporary_path, is_error

	echo  ">UpdateLineInformationXML  """+ LineInfoXML_Path +""""

	Dim  ec : Set ec = new EchoOff
	is_error = False

	Set root = LoadXML( LineInfoXML_Path, Empty )
	Set xml = root.ownerDocument
	For Each file_element  In root.selectNodes( "./File" )

		'// Read from information XML file
		Set info_elements = file_element.selectNodes( "./Info" )
		info_num = 0
		Set info_element = info_elements( info_num )
		error_line_text = Empty
		error_line_num = Empty
		line_text = info_element.selectSingleNode( "./Text/text()" ).nodeValue
		last_update_line_num = 1


		'// Open "source_file"
		source_path = GetFullPath( file_element.getAttribute( "name" ),_
			GetParentFullPath( LineInfoXML_Path ) )
		Set source_file = OpenForRead( source_path )
		ec = Empty
		echo  """"+ source_path +""" count="& info_elements.Length
		Set ec = new EchoOff

		Do
			Do Until  source_file.AtEndOfStream
				line = source_file.ReadLine()

				'// Search in line
				If InStr( line, line_text ) > 0 Then

					'// Write line number to information XML file
					XmlWrite  info_element, "./Line", CStr( source_file.Line - 1 )
					last_update_line_num = source_file.Line

					'// Delete ERROR tag
					Set error_tag = info_element.selectSingleNode( "./ERROR" )
					If not error_tag is Nothing Then
						info_element.removeChild  error_tag
					End If

					'// Echo
					ec = Empty
					echo  source_path +"("& source_file.Line - 1 &"):"+line_text
					Set ec = new EchoOff

					'// Set next "line_text"
					info_num = info_num + 1
					If info_num < info_elements.Length Then
						Set info_element = info_elements( info_num )
						line_text = info_element.selectSingleNode( "./Text/text()"_
							).nodeValue
					Else
						Exit Do
					End If
				End If
			Loop
			source_file = Empty


			If info_num < info_elements.Length Then
				is_error = True

				If IsEmpty( error_line_text ) Then _
					error_line_text = line_text
				If IsEmpty( error_line_num ) Then _
					error_line_num = last_update_line_num


				'// Set "candidate_line"
				Set candidate_line = new ArrayClass
				Set source_file = OpenForRead( source_path )
				Do Until  source_file.AtEndOfStream
					line = source_file.ReadLine()

					'// Search in line
					If InStr( line, line_text ) > 0 Then
						candidate_line.Add  source_file.Line - 1
					End If
				Loop
				source_file = Empty


				'// Write "candidate_line"
				Set error_tag = info_element.selectSingleNode( "./ERROR" )
				If error_tag is Nothing Then _
					Set error_tag = xml.createElement( "ERROR" )
				error_tag.setAttribute  "candidate_line", candidate_line.CSV
				Set line_tag = info_element.selectSingleNode( "./Line" )
				info_element.insertBefore  error_tag, line_tag.nextSibling


				'// Set next "line_text"
				info_num = info_num + 1
				If info_num >= info_elements.Length Then _
					Exit Do

				Set info_element = info_elements( info_num )
				line_text = info_element.selectSingleNode( "./Text/text()"_
					).nodeValue


				'// Set "source_file" pointer
				Set source_file = OpenForRead( source_path )
				For  i = 0  To last_update_line_num - 1
					source_file.SkipLine
				Next
			Else
				Exit Do
			End If
		Loop

		If is_error Then
			Exit For
		End If
	Next

	temporary_path = GetTempPath( "UpdateLineInfoXML_*.xml" )
	mkdir_for  temporary_path
	root.ownerDocument.save  temporary_path
	move_ren  temporary_path, LineInfoXML_Path

	If is_error Then
		Raise  1, "<ERROR msg=""Not found any lines matched with keyword"""+_
			" file="+ vbCRLF+ """"+ XmlAttr( source_path ) + """ after_line="""& _
			error_line_num &"""><![CDATA["+ vbCRLF+_
			error_line_text +vbCRLF+"]]></ERROR>"
	End If
End Sub


 
'********************************************************************************
'  <<< [CheckCountOfLineInformationXML] >>> 
'********************************************************************************
Sub  CheckCountOfLineInformationXML( LineInfoXML_Path, Keywords )

	'// Set "re" : Regular Expression
	Set re = CreateObject("VBScript.RegExp")
	re.IgnoreCase = False
	re.Global = True

	pattern = ""
	For Each keyword  In Keywords
		pattern = pattern + "(\b"+ keyword +"\b)|"
	Next
	re.Pattern = Left( pattern, Len( pattern ) - 1 )


	echo  ""
	echo  "File name : Keyword count, No keyword count, Information count in XML"
	echo  "---------------------------------------------------------------------"


	'// Loop by file
	is_error = False
	Set root = LoadXML( LineInfoXML_Path, Empty )
	For Each file_element  In root.selectNodes( "./File" )

		'// Set "info_count_in_xml"
		Set info_elements = file_element.selectNodes( "./Info" )
		info_count_in_xml = info_elements.Length

		'// Set "no_keyword_count_in_xml"
		no_keyword_count_in_xml = 0
		For Each info_element  In info_elements
			If info_element.getAttribute( "keyword" ) = "no" Then _
				no_keyword_count_in_xml = no_keyword_count_in_xml + 1
		Next


		'// Set "matches.Count" in source file named by XML attribute
		source_path = file_element.getAttribute( "name" )
		text = ReadFile( source_path )
		Set matches = re.Execute( text )


		'// echo count
		echo  source_path +" : "& matches.Count &", "& no_keyword_count_in_xml &", "& info_count_in_xml

		'// echo no information line number
		If matches.Count + no_keyword_count_in_xml > info_count_in_xml Then
			is_error = True

			'// Set "info_tag_line_nums"
			ReDim  info_tag_line_nums( info_elements.Length - 1 )
			i = 0
			For Each info_element  In info_elements
				info_tag_line_nums( i ) = _
					CInt2( info_element.selectSingleNode( "./Line/text()" ).nodeValue )
				i = i + 1
			Next

			'// Set "match_line_nums"
			RegExp_FirstIndex_To_LineNum  matches, text, match_line_nums  '//[out]match_line_nums

			'// echo no information line number
			echo  "Check following lines ..."
			For Each match_line_num  In match_line_nums
				is_found = False
				For i = 0  To UBound( info_tag_line_nums )
					If info_tag_line_nums(i) = match_line_num Then _
						is_found = True : Exit For
				Next
				If not is_found Then
					echo  source_path +"("& match_line_num &")"
				End If
			Next
		End If
	Next

	If is_error Then  Raise 1, "Line information count is few"
End Sub


 
'********************************************************************************
'  <<< [IsBaseOfALogarithm2] >>> 
'********************************************************************************
Function  IsBaseOfALogarithm2( Value )
	Select Case  VarType( Value )
		Case  vbInteger, vbLong : '// Do Nothing
		Case Else : Err.Raise  13
	End Select
	If Value <= 0 Then
		If Value = &h80000000 Then
			IsBaseOfALogarithm2 = True
		Else
			IsBaseOfALogarithm2 = False
		End If
	Else
		int_value = Value
		Do
			If int_value and 1 Then
				IsBaseOfALogarithm2 = ( int_value = 1 )
				Exit Function
			End If
			int_value = int_value / 2
		Loop
	End If
End Function


 
